routes/web.php
<?php
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/',  function () {
    return view('welcome');
});

Auth::routes();

Route::get('/forum', 'ForumController@index')->name('forum');

Route::resource('discussion', 'DiscussionsController');

Route::get('/discussion/{slug}/', [
    'uses'   =>  'DiscussionsController@show',
    'as'     =>  'discussion'
]);

Route::get('/channel/{slug}/', [
    'uses'   =>  'ForumController@channel',
    'as'     =>  'channel'
]);

//Social auth routes
Route::get('socialauth/{provider}', 'Auth\SocialAuthController@redirectToProvider');
Route::get('socialauth/{provider}/callback', 'Auth\SocialAuthController@handleProviderCallback');



Route::group(['middleware' => 'auth'], function(){
    Route::resource('channels', 'ChannelsController');
    Route::post('channel/delete', 'ChannelsController@destroy');
    Route::post('channel/update', 'ChannelsController@update');
});

Route::post('reply/store', 'ReplyController@store');

Route::post('like/store', 'LikesController@store');

Route::post('/reply/unlike', [
    'uses' => 'LikesController@destroy',
    'as' => 'reply.unlike'
]);

Route::get('/edit/profile', [
   'uses'   =>  'ProfileController@edit',
   'as'     =>  'edit.profile'
]);

Route::post('/edit/profile/save', [
    'uses'   =>  'ProfileController@store',
    'as'     =>  'profile.store'
]);

Route::get('/changePassword','ChangePasswordController@showChangePasswordForm')->name('changePassword.page');
Route::post('/changePassword','ChangePasswordController@changePassword')->name('changePassword');

Route::get('/subscribe/{id}','SubscribesController@subscribe')->name('subscribe');
Route::get('/unsubscribe/{id}','SubscribesController@unSubscribe')->name('unSubscribe');

Route::get('/results', function(){
   $dis = \App\Discussion::where('title', 'like', '%' . request('search') . '%')->get();

   return view('result')->with('dis', $dis);
});

Route::get('/best-answer/{id}', [
    'uses'  =>  'ReplyController@bestAnswer',
    'as'    =>  'best.reply'
]);

//Route::get('/testing', function(){
//   return view('testing');
//});


Route::get('/notifications', function(){
   return view('noti')->with('notis', \App\Notification::all());
})->name('noti');

app/Discussion.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

use Auth;

class Discussion extends Model
{
    protected $fillable = ['user_id', 'channel_id', 'title', 'content', 'slug'];

    public function channel()
    {
        return $this->belongsTo('App\Channel');
    }

    public function user()
    {
        return $this->belongsTo('App\User');
    }

    public function replies()
    {
        return $this->hasMany('App\Reply');
    }

    public function subscribers()
    {
        return $this->hasMany('App\Subscribe');
    }

    public function is_subscribe()
    {
        $id = Auth::id();

        $subscribers = array();

        foreach($this->subscribers as $s):
            array_push($subscribers, $s->user_id);
        endforeach;

        if(in_array($id, $subscribers)):
            return true;
            else:
                return false;
        endif;
    }

    public function notifications()
    {
        return $this->hasMany('App\Notification');
    }
}

app/Http/Controllers/DiscussionsController.php
<?php

namespace App\Http\Controllers;

use Auth;
use App\Channel;
use App\Discussion;
use Illuminate\Http\Request;

class DiscussionsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('discussions.index')->with('discussions', Discussion::all())
                                              ->with('channels', Channel::all());
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
           'title'  =>  'required'
        ]);

        $dis = new Discussion();

        $dis->title = $request->title;
        $dis->content = $request->content1;
        $dis->user_id = Auth::user()->id;
        $dis->channel_id = $request->category_id;
        $dis->slug = str_slug($request->title);
        $dis->save();

//        return response()->json('123'); ajax version
        return redirect()->route('discussion', ['slug' => $dis->slug]);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($slug)
    {
        $discussion = Discussion::where('slug' , $slug)->first();
        $best_reply = $discussion->replies->where('best_reply', 1)->first();
        return view('discussions.show')->with('d', $discussion )->with('bestReply', $best_reply);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/discussions/index.blade.php
@extends('layouts.app')

@section('content')

    <div class="card">
        <div class="card-header">Dashboard</div>

        <div class="card-body">
            @if (session('status'))
                <div class="alert alert-success" role="alert">
                    {{ session('status') }}
                </div>
            @endif

            <form action="{{route('discussion.store')}}" method="post" id="upload_form" enctype="multipart/form-data">

                <div class="modal-body">
                    {{ csrf_field() }}
                    <div class="form-group">

                        <label for="title">Title</label>
                        <input type="text" name="title" id="title" class="form-control" placeholder="title of discussion"><br>
                        <label for="channels">Pick a channel:</label>
                        <select name="category_id" class="form-control">
                            @foreach($channels as $channel)
                                <option value="{{$channel->id}}">{{$channel->title}}</option>
                            @endforeach
                        </select><br>

                        <label for="content">Ask a question</label>
                        <textarea id="content1" name="content1" class="form-control gg" cols="20" rows="15"></textarea>

                    </div>

                </div>
                <div class="modal-footer">
                    <button type="submit" id="add" class="btn btn-primary pull-right">Create discussion</button>
                </div>

            </form>
        </div>
    </div>


    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js"></script>
    <link href="https://cdnjs.cloudflare.com/ajax/libs/summernote/0.8.9/summernote-lite.css" rel="stylesheet">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/summernote/0.8.9/summernote-lite.js"></script>




    {{--<script src="{{ asset('/discussionModalScript/jQuery.js') }}"></script>--}}

@endsection

resources/views/discussions/show.blade.php
@extends('layouts.app')

@section('content')
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>

    <div class="container1">
    <div class="card">
        <div class="card-header">
            <img src="{{$d->user->avatar}}" width="40px" height="43px">&nbsp;&nbsp;
            <span>{{$d->user->name}}, <b>{{$d->created_at->diffForHumans()}}</b></span>

            <input type="hidden" class="disId" value="{{$d->id}}">
        </div>

        <div class="card-body">
            <h4 class="text-center">
                {{$d->title}}
            </h4>
            <hr>
            <p class="text-center">
                {{$d->content}}
            </p>

            <hr>

            @if($bestReply)
                <div class="text-center" style="padding: 40px">
                    <h4 class="text-center">Best Answer</h4>
                    <div class="card">
                        <div class="card-headerp-3 mb-2" style="background: #DFF0D8">
                            <img src="{{$bestReply->user->avatar}}" width="40px" height="43px">&nbsp;&nbsp;
                            <span>{{$bestReply->user->name}}</span>
                        </div>

                        <div class="card-body">
                            {{$bestReply->content}}
                        </div>
                    </div>
                </div>
            @endif


        </div>

        <div class="card-footer">
            {{$d->replies->count()}} Replies
            <a href="{{route('channel', ['slug'=>$d->channel->slug])}}" class="float-right btn btn-outline-secondary">{{$d->channel->title}}</a>
        </div>
    </div><br>


    @foreach($d->replies as $r)
        <div class="card">
            <div class="card-header">
                <img src="{{$r->user->avatar}}" width="40px" height="43px">&nbsp;&nbsp;
                <span>{{$r->user->name}}</span>

                @if(!($bestReply))
                    @if(Auth::id() == $d->user->id)
                        <a href="{{route('best.reply', ['id' => $r->id])}}" class="float-right btn btn-xs btn-info">Mart as best answer</a>
                    @endif
                @endif

                <input class="replyId" type="hidden" value="{{$r->id}}">
            </div>

            <div class="card-body">
                <p class="text-center">
                    {{$r->content}}
                </p>
            </div>

            <div class="card-footer">
                {{csrf_field()}}
                @if($r->is_liked_by_auth_user())
                    <a class="btn btn-danger unlike" data-id="{{$r->id}}">Unlike</a>
                @else
                    <a class="btn btn-success like" data-id="{{$r->id}}">Like</a>
                @endif
                <span class="badge badge-pill badge-primary">{{$r->likes->count()}}</span> Likes
            </div>
        </div>
    @endforeach
        </div>

        @if(Auth::check())
            (Add new reply)

            <a href="" id="new" class="pull-right" data-toggle="modal" data-target="#exampleModal">
                <i class="fas fa-plus"></i>
            </a>

            <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">

                <form  method="post" id="upload_form" enctype="multipart/form-data">

                    <div class="modal-dialog" role="document">

                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title" id="header">Add a new reply</h5>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                {{ csrf_field() }}
                                <div class="form-group">

                                    <textarea id="reply" name="reply" class="form-control" cols="20" rows="15"></textarea>
                                    <input type="hidden" name="saveId" class="saveId" value="">
                                </div>

                            </div>
                            <div class="modal-footer">
                                <button type="submit" id="add" class="btn btn-primary pull-right">Add</button>
                                <button type="submit" id="delete" class="btn btn-danger pull-right" style="display: none" data-dismiss="modal">Delete</button>
                                <button type="submit" id="update" class="btn btn-success pull-right" style="display: none" data-dismiss="modal">Save Changes</button>
                            </div>

                        </div>
                    </div>
                </form>

            </div>

            <script src="{{ asset('/replyModalScript/jQuery.js') }}"></script>

        @else
                Login to add a reply
        @endif

@endsection